#!/usr/bin/perl
# delete_mod.cgi
# Delete selected modules from webmin, without asking

require './webmin-lib.pl';
&ReadParse();
&error_setup($text{'delete_err'});
@mods = split(/\0/, $in{'mod'});

# check if any other module depends on those to be deleted
foreach $minfo (&get_all_module_infos()) {
	if (&check_os_support($minfo) && &indexof($minfo->{'dir'}, @mods) < 0) {
		foreach $d (split(/\s+/, $minfo->{'depends'})) {
			$depends{$d} = $minfo->{'desc'};
			}
		}
	}
foreach $m (@mods) {
	%minfo = &get_module_info($m);
	%minfo = &get_theme_Info($m) if (!%minfo);
	if (!-l "$root_directory/$m" && $depends{$m}) {
		&error(&text('delete_edep', "<tt>$minfo{'desc'}</tt>",
			     "<tt>$depends{$m}</tt>"));
		}
	}

# ask the user if he is sure
if (!$in{'confirm'}) {
	&header($text{'delete_title'}, "");
	print "<hr>\n";
	print "<p><form action=delete_mod.cgi>\n";
	foreach $m (@mods) {
		local %minfo = &get_module_info($m);
		if (!%minfo) {
			$theme++;
			%minfo = &get_theme_info($m);
			}
		print "<input type=hidden name=mod value=$m>\n";
		$total += &disk_usage_kb("$root_directory/$m")
			if (!-l "$root_directory/$m");
		$descs .= " , " if ($descs);
		$descs .= "<b>$minfo{'desc'}</b>";
		}
	print "<center>",&text($theme ? 'delete_rusure2' : 'delete_rusure',
			       int($total), $descs),"<p>",
	      "<input type=submit name=confirm value='$text{'delete'}'>",
	      "</form></center><hr>\n";
	&footer("", $text{'index_return'});
	exit;
	}

# delete the selected modules or themes
foreach $m (split(/\0/, $in{'mod'})) {
	next if (!$m || !-d "$root_directory/$m");
	local (%minfo, %cinfo);
	%minfo = &get_module_info($m);
	%minfo = &get_theme_info($m) if (!%minfo);
	if ($minfo{'clone'}) {
		# Deleting a clone
		&read_file("$config_directory/$m/clone", \%cinfo);
		unlink("$root_directory/$m");
		system("rm -rf $config_directory/$m");
		if ($gconfig{'theme'}) {
			unlink("$root_directory/$gconfig{'theme'}/$m");
			}
		push(@mdesc, &text('delete_desc1', $minfo{'desc'},
				   $minfo{'clone'}));
		}
	else {
		# Delete any clones of this module
		local @mst = stat("$root_directory/$m");
		opendir(DIR, $root_directory);
		foreach $l (readdir(DIR)) {
			@lst = stat("$root_directory/$l");
			if (-l "$root_directory/$l" && $lst[1] == $mst[1]) {
				unlink("$root_directory/$l");
				system("rm -rf $config_directory/$l");
				}
			}
		closedir(DIR);

		open(TYPE, "$root_directory/$m/install-type");
		chop($type = <TYPE>);
		close(TYPE);

		# Deleting the real module
		$pwd = "$root_directory/$m";
		local $size = &disk_usage_kb($pwd);
		push(@mdesc, &text('delete_desc2', "<b>$minfo{'desc'}</b>",
				   "<tt>$pwd</tt>", $size));
		if ($type eq 'rpm') {
			# This module was installed from an RPM .. rpm -e it
			system("rpm -e wbm-$m");
			}
		else {
			# Module was installed from a .wbm file .. just rm it
			system("rm -rf $root_directory/$m");
			}
		}
	&webmin_log("delete", undef, $m, { 'desc' => $minfo{'desc'} });
	}
unlink("$config_directory/module.infos.cache");

&header($text{'delete_title'}, "");
print "<hr>\n";
print $text{'delete_msg'},"<p>\n";
print "<ul>\n";
for($i=0; $i<@mdesc; $i++) {
	print $mdesc[$i],"<p>\n";
	}
print "</ul><p>\n";
print "<hr>\n";
&footer("", $text{'index_return'});

